
(function($){$.fn.jsonSuggest=function(searchData,settings){var defaults={minCharacters:1,maxResults:undefined,wildCard:"",caseSensitive:false,notCharacter:"!",maxHeight:350,highlightMatches:true,onSelect:undefined,onError:undefined,ajaxResults:false,width:undefined,keyDelay:0,customSettings:undefined};settings=$.extend(defaults,settings);if(typeof settings.customSettings==="object"&&settings.customSettings!==null){this.data("jsonSuggestCustomSettings",settings.customSettings);}
return this.each(function(){var inputField=$(this);var wildCardPatt=new RegExp(regexEscape(settings.wildCard||""),"g");var results=$("<table cellSpacing=0 />");var currentSelection;var pageX;var pageY;if(typeof settings.customSettings==="function"){inputField.data("jsonSuggestCustomSettings",settings.customSettings(this));}
function regexEscape(txt,omit){var specials=["/",".","*","+","?","|","(",")","[","]","{","}","\\"];if(omit){for(var i=0;i<specials.length;i++){if(specials[i]===omit){specials.splice(i,1);}}}
var escapePatt=new RegExp("(\\"+specials.join("|\\")+")","g");return txt.replace(escapePatt,"\\$1");}
var busyIndicator=null;var resultIndicator=null;if(settings.ajaxResults===true){var indicatorHeight=inputField.outerHeight(false);busyIndicator=$("<span class='jsonSuggestBusyIndicator'></span>").height(indicatorHeight);busyIndicator.insertAfter(inputField);resultIndicator=$("<span class='jsonSuggestResultIndicator'>0 results</span>");resultIndicator.css({"height":indicatorHeight+"px","line-height":indicatorHeight+"px"});resultIndicator.insertAfter(inputField);}
function selectResultItem(item){inputField.focus();inputField.val(item.displayString);clearAndHideResults();if(typeof settings.onSelect==="function"){settings.onSelect(inputField.get(0),item,inputField.data("jsonSuggestCustomSettings"));}}
function setHoverClass(el){$("tr.resultItem",results).removeClass("hover");$(el).addClass("hover");currentSelection=el;}
function buildResults(resultObjects,filterTxt){clearAndHideResults();if(resultObjects.length==0){if(settings.ajaxResults===true)resultIndicator.show();return;}
if(resultObjects.length==1&&resultObjects[0].isError){if(typeof settings.onError==="function"){settings.onError(inputField.get(0),resultObjects[0].errorMessage);}
return;}
filterTxt="("+filterTxt+")";var bOddRow=true;var tr;var filterPatt=settings.caseSensitive?new RegExp(filterTxt,"g"):new RegExp(filterTxt,"ig");var thead=$("thead",results);if(thead.length==0){thead=$("<thead />");tr=$("<tr />");var headers=resultObjects[0].headers;var sortCol=resultObjects[0].sortCol;var sortAsc=resultObjects[0].sortAsc;for(var i=0;i<headers.length;i++){var th=$("<th noWrap />");th.html(headers[i]);if(i==sortCol)th.addClass(sortAsc?"sortColAsc":"sortColDesc");tr.append(th);}
tr.click(function(){inputField.focus();inputField.val(inputField.val());});thead.append(tr);results.append(thead);}
var filters=resultObjects[0].filters;var nextFilterIdx=0;var tbody=$("tbody",results);if(tbody.length==0){tbody=$("<tbody />");results.append(tbody);}
for(var i=1;i<resultObjects.length;i++){tr=$("<tr />");var data=resultObjects[i].data;for(j=0;j<data.length;j++){var td=$("<td />");var text=data[j];if(text=="")text="&nbsp;";if(settings.highlightMatches===true&&j==filters[nextFilterIdx]){text=text.replace(filterPatt,"<strong>$1</strong>");nextFilterIdx++;}
td.html(text);tr.append(td);}
nextFilterIdx=0;tr.addClass("resultItem").addClass(bOddRow?"odd":"even").click(function(n){return function(){selectResultItem(resultObjects[n]);};}(i)).mouseover(function(el){return function(){setHoverClass(el);};}(tr));tbody.append(tr);bOddRow=!bOddRow;if(typeof settings.maxResults==="number"&&i==settings.maxResults){break;}}
currentSelection=undefined;results.width(Math.max(results.width(),inputField.width()+5));results.height("auto");results.show();if(results.height()>settings.maxHeight){results.css({"overflow":"auto","height":settings.maxHeight+"px"});}}
function clearAndHideResults()
{$("tbody",results).empty();results.hide();}
function runSuggest(e){if(this.value.length<settings.minCharacters){clearAndHideResults();if(settings.keyDelay>0&&this.jsonSuggestTimerId){window.clearTimeout(this.jsonSuggestTimerId);this.jsonSuggestTimerId=null;}
return false;}
if(settings.keyDelay>0){if(this.jsonSuggestTimerId){window.clearTimeout(this.jsonSuggestTimerId);}
this.jsonSuggestTimerId=window.setTimeout(function(txt,e){return function(){txt.jsonSuggestTimerId=null;internalRunSuggest.apply(txt,[e]);}}(this,e),settings.keyDelay);return false;}else{internalRunSuggest.apply(this,[e]);}
function internalRunSuggest(e){var resultObjects=[];var filterTxt;if(!settings.wildCard){filterTxt=regexEscape(this.value);}else{filterTxt=regexEscape(this.value,settings.wildCard).replace(wildCardPatt,".*");}
var match=true;var filterPatt;if(settings.notCharacter&&filterTxt.indexOf(settings.notCharacter)===0){filterTxt=filterTxt.substr(settings.notCharacter.length,filterTxt.length);if(filterTxt.length>0)match=false;}
filterTxt=filterTxt||".*";filterTxt=settings.wildCard?"^"+filterTxt:filterTxt;filterPatt=settings.caseSensitive?new RegExp(filterTxt):new RegExp(filterTxt,"i");if(settings.ajaxResults===true){resultIndicator.hide();busyIndicator.show();searchData(this,this.value,settings.wildCard,settings.caseSensitive,settings.notCharacter,inputField.data("jsonSuggestCustomSettings"),searchDataComplete);}else{for(var i=0;i<searchData.length;i++){if(filterPatt.test(searchData[i].text)===match){resultObjects.push(searchData[i]);}}
buildResults(resultObjects,filterTxt);}
function searchDataComplete(resultObjects){busyIndicator.hide();if(typeof resultObjects==="string"){resultObjects=JSON.parse(resultObjects);}
buildResults(resultObjects,filterTxt);}}}
function keyListener(e){switch(e.keyCode){case 13:$(currentSelection).trigger("click");return false;case 40:if(typeof currentSelection==="undefined"){currentSelection=$("tr.resultItem:first",results).get(0);}else{currentSelection=$(currentSelection).next().get(0);}
setHoverClass(currentSelection);if(currentSelection){$(results).scrollTop(currentSelection.offsetTop);}
return false;case 38:if(typeof currentSelection==="undefined"){currentSelection=$("tr.resultItem:last",results).get(0);}else{currentSelection=$(currentSelection).prev().get(0);}
setHoverClass(currentSelection);if(currentSelection){$(results).scrollTop(currentSelection.offsetTop);}
return false;case 39:case 37:case 36:case 35:break;default:runSuggest.apply(this,[e]);}}
$(results).addClass("jsonSuggestResults").css({"top":(inputField.position().top+inputField.height()+5)+"px","left":inputField.position().left+"px","width":settings.width||(inputField.width()+5)+"px"}).hide();inputField.after(results).keyup(keyListener).keypress(function(e){if(e.keyCode==13)e.preventDefault();}).blur(function(e){var resPos=$(results).offset();resPos.bottom=resPos.top+$(results).height();resPos.right=resPos.left+$(results).width();if(pageY<resPos.top||pageY>resPos.bottom||pageX<resPos.left||pageX>resPos.right){$(results).hide();}}).focus(function(e){$(results).css({"top":(inputField.position().top+inputField.height()+5)+"px","left":inputField.position().left+"px"});if($("tr.resultItem",results).length>0){$(results).show();}}).prop("autocomplete","off");$().mousemove(function(e){pageX=e.pageX;pageY=e.pageY;});settings.notCharacter=regexEscape(settings.notCharacter||"");if(!settings.ajaxResults){if(typeof searchData==="function"){searchData=searchData();}
if(typeof searchData==="string"){searchData=JSON.parse(searchData);}}});};})(jQuery);